#include <SD.h>

#define SDCARD_CSN_PIN 10

#ifdef DO_SERIAL
bool sdCardOk = false;
#endif

byte SDCard_phase = 0;

char filename[8] = "000.txt";

File dataFile;

void SDCard_setup() {
  SD.begin(SDCARD_CSN_PIN);

  for (int i = 0; i < 10000; i++) {
    // don't use sprintf because it adds 1200 bytes to program size!
    filename[0] = '0' + (i / 100 % 10);
    filename[1] = '0' + (i / 10 % 10);
    filename[2] = '0' + (i % 10);
    if ( ! SD.exists(filename) )
      break;
  }

  dataFile = SD.open(filename, FILE_WRITE);

  /*File dataFile = SD.open(filename, FILE_WRITE);
  
#ifdef DO_SERIAL
  sdCardOk = (dataFile != NULL);
  if ( sdCardOk ) {
    Serial.print("Using file: ");
    Serial.println(filename);
    //dataFile.println("It works!");
    //dataFile.flush();
  }
  else
    Serial.print("SD file open failed");
#endif

  dataFile.close();*/
}

#define SD_READABLE


#ifdef SD_READABLE
void sdcomma() {
  dataFile.print(", ");
}
#endif

void SDCard_loop() {

  switch (SDCard_phase) {
    case 0:
    //dataFile = SD.open(filename, FILE_WRITE);
    break;

    case 1:
    if ( dataFile ) {
      dataFile.print(GPS_data.hour);
      sdcomma();
      dataFile.print(GPS_data.minute);
      sdcomma();
      dataFile.print(GPS_data.second);
      sdcomma();
      dataFile.print(vbat_raw);
      sdcomma();
    }
    break;

    case 2:
    if ( dataFile ) {
      dataFile.print(GPS_data.numSV);
      sdcomma();
      dataFile.print(GPS_data.lat);
      sdcomma();
      dataFile.print(GPS_data.lon);
      sdcomma();
      dataFile.print(GPS_data.height);
      sdcomma();
    }
    break;

    case 3:
    if ( dataFile ) {
      dataFile.print(GPS_data.velD);
      sdcomma();
      dataFile.print(GPS_data.gSpeed);
      sdcomma();
      dataFile.print(GPS_data.heading);
      sdcomma();
    }
    break;

    case 4:
    if ( dataFile ) {
      //dataFile.print(MS5611_D1);
      //sdcomma();
      //dataFile.print(MS5611_D2);    
      //sdcomma();
      dataFile.print(BMP280_adc_T);
      sdcomma();
      dataFile.println(BMP280_adc_P);
    }
    break;

    case 5:
    if ( dataFile ) {
      dataFile.flush();
      //dataFile.close();
    }
    break;
  }

  SDCard_phase = (SDCard_phase + 1) % 6;
}
