#include <Wire.h>
#include <SPI.h>

//#define DO_SERIAL

#define _SS_MAX_RX_BUFF 128

#include "i2cStuff.h"
//#include "MPU6050.h"
//#include "MS5611.h"
#include "BMP280.h"
//#include "Si7021.h"
//#include "DS18B20.h"
#include "GPS.h"
#include "printf.h"
#include "vbat.h"
//#include "GSM.h"
#include "SDCard.h"
#include "buzzer.h"
#include "cutdown.h"
#include "RF24.h"

void setup() {
  
  cutdown_setup();
  
  Wire.begin();

  delay(200);
  
#ifdef DO_SERIAL
  Serial.begin(9600);
  printf_begin();
#endif

  //MPU6050_setup();
  //MS5611_setup();
  BMP280_setup();
  //Si7021_setup();
  //DS18B20_setup();
  GPS_setup();
  RF24_setup();
  SDCard_setup();
  vbat_setup();
  //GSM_setup();
  buzzer_setup();
}

void fastLoop() {
  GPS_flush();
  //GSM_flush();
  RF24_loop();
}

//void (* tasks[])() = { GSM_loop, MPU6050_loop, BMP280_loop, DS18B20_loop, SDCard_loop, MS5611_loop, Si7021_loop, buzzer_loop, vbat_loop, buzzer_loop };
void (* tasks[])() = { BMP280_loop, SDCard_loop, buzzer_loop, vbat_loop, buzzer_loop, cutdown_loop };

byte taskIndex = 0;

void loop() {

  static unsigned long lastTaskTime = 0;

  fastLoop();

  unsigned long now = millis();
  if ( now - lastTaskTime > 100 ) {
    tasks[taskIndex]();
    taskIndex = (taskIndex + 1) % (sizeof(tasks) / sizeof(void*));
    
#ifdef DO_SERIAL
    Serial.println();
#endif
    lastTaskTime = millis();
  }

}
