
unsigned long i2cErrorCount = 0;

void logError(char* str) {
#ifdef DO_SERIAL
  Serial.println(str);
#else
  i2cErrorCount++;
#endif
}

void twiWriteData(byte deviceAddress, byte* data, byte length)
{
  Wire.beginTransmission(deviceAddress);
  
  if (!Wire.write(data, length))
#ifdef DO_SERIAL
    Serial.println("Wire: error doing write()");
#else
    i2cErrorCount++;
#endif

  if (Wire.endTransmission()) {
#ifdef DO_SERIAL
    Serial.print("Wire: error when sending command: ");
    Serial.println(*data, HEX);
#else
    i2cErrorCount++;
#endif
  }
}

void twiWriteByte(byte deviceAddress, byte b) {
  twiWriteData( deviceAddress, &b, 1 );  
}

void twiWriteBytes(byte deviceAddress, byte b0, byte b1) {
  byte d[2] = {b0,b1};
  twiWriteData( deviceAddress, d, 2 );  
}

void twiReadData(byte deviceAddress, byte command, byte* dest, byte numBytes)
{
  twiWriteData(deviceAddress, &command, 1);
  Wire.requestFrom(deviceAddress, numBytes);
  //if ( Wire.available() != numBytes ) 
  //  logError("Wire: available() gave unexpected result");
  while ( Wire.available() != numBytes );
  byte index = numBytes - 1;
  for (byte i = 0; i < numBytes; i++)
    dest[index--] = Wire.read();
}

